﻿Imports System.Text.RegularExpressions

Public Class FestivalTextBox

    Sub New()

        ' Dieser Aufruf ist für den Designer erforderlich.
        InitializeComponent()

        ' Fügen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.

    End Sub

    Dim i As Integer = 0
    Dim codeLength As Integer = 0
    Dim isCode As Boolean = False
    Dim colorList As New List(Of Color)

    Public Overrides Property Text As String
        Get
            Return rtb_Conversation.Text
        End Get
        Set(value As String)
            rtb_Conversation.Text = value
        End Set
    End Property

    Public Property SelectionColor As Color
        Get
            Return rtb_Conversation.SelectionColor
        End Get
        Set(value As Color)
            rtb_Conversation.SelectionColor = value
        End Set
    End Property

    Public Sub ScrollToCaret()
        rtb_Conversation.ScrollToCaret()
    End Sub

    Public Sub Append(ByVal Text As String)
        Dim cOldColor As Color = rtb_Conversation.SelectionColor
        Dim newText As String = Text
        colorList.Clear()
        i = 0
        Try
            Dim Matches = Regex.Matches(newText, "\'?#[a-fA-F0-9]{6}")
            For Each M As Match In Matches
                colorList.Add(ColorTranslator.FromHtml(M.Value.Replace("'", "")))
                newText = newText.Replace(M.Value, "ᴦ" & i)
                i += 1
            Next
        Catch ex As Exception

        End Try
        Dim doneString As String = ""
        For Each C As Char In newText.Replace(vbCrLf, "")
            Select Case C
                Case CChar("ᴮ")
                    doneString += C.ToString
                    rtb_Conversation.SelectionFont = New Font("Segoe UI", 10, FontStyle.Bold)
                Case CChar("ᴵ")
                    doneString += C.ToString
                    rtb_Conversation.SelectionFont = New Font("Segoe UI", 10, FontStyle.Italic)
                Case CChar("ᵁ")
                    doneString += C.ToString
                    rtb_Conversation.SelectionFont = New Font("Segoe UI", 10, FontStyle.Underline)
                Case CChar("ᴿ")
                    doneString += C.ToString
                    rtb_Conversation.SelectionFont = New Font("Segoe UI", 10, FontStyle.Regular)
                Case Is <> "ᴦ"c
                    If codeLength = 0 Then
                        isCode = False
                    Else
                        codeLength -= 1
                    End If
                    If isCode = True Then
                        doneString += C.ToString
                    Else
                        rtb_Conversation.AppendText(C.ToString)
                        doneString += C.ToString
                    End If
                Case Else
                    doneString += C.ToString
                    Dim Remaining As String = newText.Replace(vbCrLf, "").Remove(0, doneString.Length)
                    Dim Code As Integer
                    Dim Matches = Regex.Matches(Remaining, "\S?[0-9]*")
                    Code = CInt(Matches(0).Value)
                    Do Until Code <= colorList.Count
                        Code = CInt(Code.ToString.Remove(Code.ToString.Length - 1, 1))
                    Loop
                    rtb_Conversation.SelectionColor = colorList(Code)
                    codeLength = Code.ToString.Length
                    isCode = True
            End Select
        Next
        rtb_Conversation.AppendText(vbCrLf)
    End Sub

End Class
